"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
Object.defineProperty(exports, "__esModule", { value: true });
exports[Symbol.toStringTag] = "Module";
var vue = require("vue");
var injectionJs = require("injection-js");
function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof2(obj2) {
      return typeof obj2;
    };
  } else {
    _typeof = function _typeof2(obj2) {
      return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
    };
  }
  return _typeof(obj);
}
function boundMethod(target, key, descriptor) {
  var fn = descriptor.value;
  if (typeof fn !== "function") {
    throw new TypeError("@boundMethod decorator can only be applied to methods not: ".concat(_typeof(fn)));
  }
  var definingProperty = false;
  return {
    configurable: true,
    get: function get() {
      if (definingProperty || this === target.prototype || this.hasOwnProperty(key) || typeof fn !== "function") {
        return fn;
      }
      var boundFn = fn.bind(this);
      definingProperty = true;
      Object.defineProperty(this, key, {
        configurable: true,
        get: function get2() {
          return boundFn;
        },
        set: function set(value) {
          fn = value;
          delete this[key];
        }
      });
      definingProperty = false;
      return boundFn;
    },
    set: function set(value) {
      fn = value;
    }
  };
}
function boundClass(target) {
  var keys;
  if (typeof Reflect !== "undefined" && typeof Reflect.ownKeys === "function") {
    keys = Reflect.ownKeys(target.prototype);
  } else {
    keys = Object.getOwnPropertyNames(target.prototype);
    if (typeof Object.getOwnPropertySymbols === "function") {
      keys = keys.concat(Object.getOwnPropertySymbols(target.prototype));
    }
  }
  keys.forEach(function(key) {
    if (key === "constructor") {
      return;
    }
    var descriptor = Object.getOwnPropertyDescriptor(target.prototype, key);
    if (typeof descriptor.value === "function") {
      Object.defineProperty(target.prototype, key, boundMethod(target, key, descriptor));
    }
  });
  return target;
}
function autobind() {
  if (arguments.length === 1) {
    return boundClass.apply(void 0, arguments);
  }
  return boundMethod.apply(void 0, arguments);
}
function Autobind() {
  return autobind;
}
function useProps() {
  const instance = vue.getCurrentInstance();
  return instance.props;
}
function useCtx() {
  const instance = vue.getCurrentInstance();
  return instance.setupContext;
}
function getCurrentApp() {
  var _a;
  return (_a = vue.getCurrentInstance()) == null ? void 0 : _a.appContext.app;
}
function getProtoMetadata(target, key, returnDesc = false) {
  if (!target)
    return [];
  const proto = Reflect.getPrototypeOf(target);
  if (!proto)
    return [];
  let res = Reflect.getMetadata(key, proto) || [];
  if (returnDesc) {
    res = res.map((k) => {
      if (typeof k === "string") {
        return {
          key: k,
          desc: getDeepOwnDescriptor(proto, k)
        };
      }
      if (typeof k === "object") {
        return {
          key: k,
          desc: getDeepOwnDescriptor(proto, k.key)
        };
      }
    });
  }
  return res;
}
function getDeepOwnDescriptor(proto, key) {
  if (!proto)
    return null;
  const desc = Reflect.getOwnPropertyDescriptor(proto, key);
  if (desc)
    return desc;
  return getDeepOwnDescriptor(Reflect.getPrototypeOf(proto), key);
}
function getEmitsFromProps(defaultProps) {
  const keys = Array.isArray(defaultProps) ? defaultProps : Object.keys(defaultProps);
  const emits = [];
  for (let key of keys) {
    if (!/^on/.test(key))
      continue;
    key = key.slice(2).replace(/Once$/, "");
    emits.push(key[0].toLowerCase() + key.slice(1));
  }
  return emits;
}
function injectService(service, defaultService) {
  return vue.inject(service.ProviderKey, defaultService);
}
const MetadataKey$4 = Symbol("Ref");
function Ref() {
  return function(target, key) {
    let list = Reflect.getMetadata(MetadataKey$4, target) || [];
    list = list.slice();
    const hasItem = list.find((k) => k === key);
    if (!hasItem)
      list.push(key);
    Reflect.defineMetadata(MetadataKey$4, list, target);
  };
}
function handler$3(targetThis) {
  const list = getProtoMetadata(targetThis, MetadataKey$4);
  if (!list || !list.length)
    return;
  for (const item of list) {
    const keyVal = vue.ref();
    Object.defineProperty(targetThis, item, {
      enumerable: true,
      configurable: true,
      get() {
        return keyVal.value;
      },
      set(v) {
        keyVal.value = v;
      }
    });
  }
}
const RefHandler = {
  key: "Ref",
  handler: handler$3
};
const MetadataKey$3 = Symbol("Computed");
function Computed() {
  return function(target, key) {
    let list = Reflect.getMetadata(MetadataKey$3, target) || [];
    list = list.slice();
    const hasItem = list.find((k) => k === key);
    if (!hasItem)
      list.push(key);
    Reflect.defineMetadata(MetadataKey$3, list, target);
  };
}
function handler$2(targetThis) {
  const list = getProtoMetadata(targetThis, MetadataKey$3, true);
  if (!list || !list.length)
    return;
  for (const item of list) {
    const desc = item.desc;
    const keyVal = vue.computed({
      get: () => {
        var _a;
        return (_a = desc.get) == null ? void 0 : _a.call(targetThis);
      },
      set: (v) => {
        var _a;
        return (_a = desc.set) == null ? void 0 : _a.call(targetThis, v);
      }
    });
    Object.defineProperty(targetThis, item.key, {
      enumerable: desc == null ? void 0 : desc.enumerable,
      configurable: true,
      get() {
        return keyVal.value;
      },
      set(v) {
        keyVal.value = v;
      }
    });
  }
}
const ComputedHandler = {
  key: "Computed",
  handler: handler$2
};
const MetadataKey$2 = Symbol("Hook");
function Hook(lifecycle) {
  return function(target, key) {
    let list = Reflect.getMetadata(MetadataKey$2, target) || [];
    list = list.slice();
    const hasItem = list.find((k) => k.key === key && k.lifecycle === lifecycle);
    if (!hasItem)
      list.push({
        key,
        lifecycle
      });
    Reflect.defineMetadata(MetadataKey$2, list, target);
  };
}
function handler$1(targetThis) {
  const list = getProtoMetadata(targetThis, MetadataKey$2);
  if (!list || !list.length)
    return;
  for (const item of list) {
    let vueFn;
    switch (item.lifecycle) {
      case "BeforeMount":
        vueFn = vue.onBeforeMount;
        break;
      case "Mounted":
        vueFn = vue.onMounted;
        break;
      case "BeforeUpdate":
        vueFn = vue.onBeforeUpdate;
        break;
      case "Updated":
        vueFn = vue.onUpdated;
        break;
      case "BeforeUnmount":
        vueFn = vue.onBeforeUnmount;
        break;
      case "Unmounted":
        vueFn = vue.onUnmounted;
        break;
      case "Activated":
        vueFn = vue.onActivated;
        break;
      case "Deactivated":
        vueFn = vue.onDeactivated;
        break;
      case "ErrorCaptured":
        vueFn = vue.onErrorCaptured;
        break;
      case "RenderTracked":
        vueFn = vue.onRenderTracked;
        break;
      case "RenderTriggered":
        vueFn = vue.onRenderTriggered;
        break;
      case "ServerPrefetch":
        vueFn = vue.onServerPrefetch;
        break;
    }
    vueFn(() => targetThis[item.key]());
  }
}
const HookHandler = {
  key: "Hook",
  handler: handler$1
};
const MetadataKey$1 = Symbol("Link");
function Link() {
  return function(target, key) {
    let list = Reflect.getMetadata(MetadataKey$1, target) || [];
    list = list.slice();
    const hasItem = list.find((k) => k === key);
    if (!hasItem)
      list.push(key);
    Reflect.defineMetadata(MetadataKey$1, list, target);
  };
}
function handler(targetThis) {
  const list = getProtoMetadata(targetThis, MetadataKey$1);
  if (!list || !list.length)
    return;
  for (const item of list) {
    const instance = vue.getCurrentInstance();
    Object.defineProperty(targetThis, item, {
      enumerable: true,
      configurable: true,
      get() {
        return instance == null ? void 0 : instance.refs[item];
      }
    });
  }
}
const LinkHandler = {
  key: "Link",
  handler
};
const GlobalStoreKey = "GlobalStoreKey";
class VueComponent {
  constructor() {
    this.props = useProps();
    this.context = useCtx();
    this.context.expose(this);
    const ThisConstructor = this.constructor;
    if (ThisConstructor.ProviderKey)
      vue.provide(ThisConstructor.ProviderKey, this);
    if (ThisConstructor.globalStore) {
      const current = vue.getCurrentInstance();
      const app = current.appContext.app;
      app.provide(GlobalStoreKey, this);
      app.getStore = () => this;
      app.getService = (token) => {
        if ((typeof token === "function" || typeof token === "object") && "ProviderKey" in token) {
          token = token.ProviderKey;
        }
        return current == null ? void 0 : current.provides[token];
      };
    }
    VueComponent.handler.forEach((handler2) => handler2.handler(this));
  }
  static get __vccOpts() {
    if (this.__vccOpts__value)
      return this.__vccOpts__value;
    const CompConstructor = this;
    return this.__vccOpts__value = __spreadProps(__spreadValues({}, CompConstructor), {
      name: CompConstructor.displayName || CompConstructor.name,
      props: CompConstructor.defaultProps || {},
      inheritAttrs: CompConstructor.inheritAttrs,
      directives: CompConstructor.directives,
      emits: (CompConstructor.emits || []).concat(getEmitsFromProps(CompConstructor.defaultProps || {})),
      setup: (props, ctx) => {
        let instance;
        if (CompConstructor.resolveComponent) {
          instance = CompConstructor.resolveComponent(CompConstructor);
        } else {
          instance = new CompConstructor();
        }
        return instance.render.bind(instance);
      }
    });
  }
  get $props() {
    return this.props;
  }
}
VueComponent.handler = [RefHandler, ComputedHandler, LinkHandler, HookHandler];
const ProviderKey = "ProviderKey";
class VueService {
  constructor() {
    const ThisConstructor = this.constructor;
    if (ThisConstructor.ProviderKey)
      vue.provide(ThisConstructor.ProviderKey, this);
    VueService.handler.forEach((handler2) => handler2.handler(this));
  }
}
VueService.handler = [RefHandler, ComputedHandler, LinkHandler, HookHandler];
const InjectorKey = Symbol("ReflectiveInjector");
const MetadataKey = Symbol("Component");
function Component(options) {
  return function(target) {
    if (!target.resolveComponent)
      target.resolveComponent = resolveComponent;
    Reflect.defineMetadata(MetadataKey, options, target);
    return injectionJs.Injectable()(target);
  };
}
function resolveComponent(target) {
  var _a;
  if (!Reflect.getMetadata("annotations", target))
    return new target();
  const parent = vue.inject(InjectorKey, void 0);
  const options = Reflect.getOwnMetadata(MetadataKey, target);
  let deps = (options == null ? void 0 : options.autoResolveDeps) ? injectionJs.resolveDependencies(target) : (options == null ? void 0 : options.providers) || [];
  if (!deps.includes(target))
    deps.unshift(target);
  if ((_a = options == null ? void 0 : options.exclude) == null ? void 0 : _a.length) {
    deps = deps.filter((k) => {
      var _a2;
      return !((_a2 = options.exclude) == null ? void 0 : _a2.includes(k));
    });
  }
  const injector = injectionJs.ReflectiveInjector.resolveAndCreate(deps, parent);
  if (options == null ? void 0 : options.globalStore) {
    const current = vue.getCurrentInstance();
    const app = current.appContext.app;
    app.provide(InjectorKey, injector);
    app.getStore = () => injector;
    app.getService = (token) => injector.get(token);
  } else {
    vue.provide(InjectorKey, injector);
  }
  return injector.get(target);
}
exports.Autobind = Autobind;
exports.Component = Component;
exports.Computed = Computed;
exports.GlobalStoreKey = GlobalStoreKey;
exports.Hook = Hook;
exports.InjectorKey = InjectorKey;
exports.Link = Link;
exports.ProviderKey = ProviderKey;
exports.Ref = Ref;
exports.VueComponent = VueComponent;
exports.VueService = VueService;
exports.getCurrentApp = getCurrentApp;
exports.getDeepOwnDescriptor = getDeepOwnDescriptor;
exports.getEmitsFromProps = getEmitsFromProps;
exports.getProtoMetadata = getProtoMetadata;
exports.injectService = injectService;
exports.useCtx = useCtx;
exports.useProps = useProps;
