import { Provider, ReflectiveInjector } from 'injection-js';
import { InjectionKey } from 'vue';
export declare const InjectorKey: InjectionKey<ReflectiveInjector>;
declare module 'vue' {
    interface App {
        getStore(): any;
        getService(token: any): any;
    }
}
export interface ComponentOptions {
    /**
     * 依赖的服务
     */
    providers?: Provider[];
    /**
     * 排除掉的服务
     */
    exclude?: Provider[];
    /**
     * 自动分析依赖
     */
    autoResolveDeps?: boolean;
    /**
     * 此注入器是否作为全局的store
     */
    globalStore?: boolean;
}
export declare function Component(options?: ComponentOptions): ClassDecorator;
export declare function resolveComponent(target: {
    new (...args: []): any;
}): any;
